//============================================================================
// Name        : Entry.hpp
// Author      : Zdeněk Kalčík
// Copyright   : @2009@
// Project 		 : BDS
//============================================================================

#ifndef ENTRY_HPP_
#define ENTRY_HPP_

#include <iostream>
#include <vector>
#include <set>
#include <string.h>
#include <stdlib.h>

using namespace std;

class Entry {
private:
	string output;
	vector<string> inputs;
	vector<string> settings;
	bool singularity;
	bool canInit;

public:
	Entry();
	Entry(string outputName);
	virtual ~Entry();
	void addInput(string input);
	void addSetting(string setting);
	string getOutput();
	void toString();
	bool canInitialize(set<string>& initializedNodes);
	int lineCount();
	string getLine(int number);
	string getInput(int number);
	bool getSingularity();
};

#endif /* ENTRY_HPP_ */
