//============================================================================
// Name        : Manager2.cpp
// Author      : Zdeněk Kalčík
// Copyright   : @2009@
// Project 		 : BDS
//============================================================================

#include "Manager2.hpp"

//key = index, value = cout leaf edges
map<int, int> leafE0;
map<int, int> leafE1;

//auxiliary set for visited nodes (usages in finding leaf edges and gxds)
set<string> visitedNods;

//key = index, value 1 = Regular, 2 = Complemented, 3 = generalized x-dominator
map<string, int> gxdd;
map<string, DdNode*> gxdNodess;

//auxiliries for AND decomposition
int maxAndCutt;
int indexMaxAndCutt;

//auxiliries for OR decomposition
int maxOrCutt;
int indexMaxOrCutt;

unsigned int inputCount;
char** inputNamess;
char** tempOutputs;

int countANDD = 0;
int countORR = 0;
int countXNORR = 0;

//PRIVATE METHODS
void findLeafEdgess(DdManager *manager, DdNode *function);
void analyzeLeafss(DdNode *node);
void add00(int index);
void add11(int index);
void findGXDD(DdNode *function);
void analyzeGXDSS(DdNode *node);
void addRR(string id);
void addCC(string id, DdNode *node);
int chooseDecompositionn();
void searchIndexMaxAndCutt();
void searchIndexMaxOrCutt();
int getGXDCountt();
void createCutt(DdManager *manager, int cutLevel);
void createGxd();
string getOutput(DdManager* manager, DdNode *function);

void initDecompositionManager(vector<string> inputNames2) {
	tempOutputs = new char*[1];
	tempOutputs[0] = new char[21];
	strcpy(tempOutputs[0], "$replaceWithRealName");

	inputCount = inputNames2.size();
	inputNamess = new char*[inputCount];
	for (unsigned i = 0; i < inputCount; i++) {
		inputNamess[i] = new char[inputNames2[i].size()];
		strcpy(inputNamess[i], inputNames2[i].c_str());
	}
}

void endDecompositionManager() {
	delete[] tempOutputs[0];
	delete[] tempOutputs;

	for (unsigned i = 0; i < inputCount; i++) {
		delete[] inputNamess[i];
	}
	delete[] inputNamess;
}

//tak tohle je bez memorry leaku...
int main2(int argc, char* argv[]) {

	DdManager *newManager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	Cudd_Quit(newManager);

DdManager *newManager2 = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	Cudd_Quit(newManager2);

	DdManager *newManager3 = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	Cudd_Quit(newManager3);

	DdManager *newManager4 = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	Cudd_Quit(newManager4);

	DdManager *newManager5 = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	Cudd_Quit(newManager5);

	DdManager *newManager6 = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	Cudd_Quit(newManager6);

	/*dManager *manager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	DdNode *one = Cudd_ReadOne(manager);
	DdNode *zero = Cudd_ReadLogicZero(manager);

	DdNode *var0 = Cudd_bddIthVar(manager, 0);
	DdNode *var1 = Cudd_bddIthVar(manager, 1);
	//DdNode *var2 = Cudd_bddIthVar(manager, 2);

	DdNode *b = Cudd_bddIte(manager, var1, one, zero);
	Cudd_Ref(b);
	DdNode *d = Cudd_bddIte(manager, var1, zero, one);
	Cudd_Ref(d);
	DdNode *e = Cudd_bddIte(manager, var0, b, d);
	Cudd_Ref(e);

	Cudd_RecursiveDeref(manager, b);
	Cudd_RecursiveDeref(manager, d);

	tempOutputs = new char*[1];
	tempOutputs[0] = new char[21];
	strcpy(tempOutputs[0], "$replaceWithRealName");

	inputNamess = new char*[2];
	inputNamess[0] = new char[3];
	strcpy(inputNamess[0], "x1");
	inputNamess[1] = new char[3];
	strcpy(inputNamess[1], "x2");

	FILE *file = fopen("bds.temp", "w");
	//writeHeadNew(structure, file);

	DdManager *newManager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
	DdNode *function = copyFunction(e, newManager, true);
	if (Cudd_IsComplement(e)) {
		DdNode *tmp = Cudd_Complement(function);
		Cudd_Ref(tmp);
		Cudd_RecursiveDeref(newManager, function);
		function = tmp;
	}

	Decomp2 *decomp = new Decomp2();
	decompositionManager(newManager, function, decomp);
	proceedDecompp(decomp, file, "F");
	delete decomp;
	fclose(file);
	Cudd_Quit(manager);


	//writeEnd(structure, argv[decoposedFilePosition], file);

	delete[] inputNamess[0];
	delete[] inputNamess[1];
	delete[] inputNamess;

	delete[] tempOutputs[0];
	delete[] tempOutputs;*/

	exit(0);
}

void decompositionManager(DdManager *originalManager, DdNode *originalFunction, Decomp2 *decomp) {
	findLeafEdgess(originalManager, originalFunction);
	findGXDD(originalFunction);
	int decompChoosen = chooseDecompositionn();
	switch (decompChoosen) {
		case AND: {
			//cout << "choosing AND decomposition, max: " << maxAndCutt << " for index: " << indexMaxAndCutt << endl;
			createCutt(originalManager, indexMaxAndCutt);
			DdManager *newManager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
			functions fs = newAND(originalManager, originalFunction, newManager);

			Decomp2 *first = new Decomp2();
			Decomp2 *second = new Decomp2();
			decomp -> save(first, second, AND);

			decompositionManager(originalManager, fs.originalFunction, first);
			decompositionManager(newManager, fs.newFunction, second);
			break;
		}
		case OR: {
			//cout << "choosing OR decomposition, max: " << maxOrCutt << " for index: " << indexMaxOrCutt << endl;
			createCutt(originalManager, indexMaxOrCutt);
			DdManager *newManager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
			functions fs = newOR(originalManager, originalFunction, newManager);

			Decomp2 *first = new Decomp2();
			Decomp2 *second = new Decomp2();
			decomp -> save(first, second, OR);

			decompositionManager(originalManager, fs.originalFunction, first);
			decompositionManager(newManager, fs.newFunction, second);
			break;
		}
		case XNOR: {
			createGxd();
			DdManager *newManager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
			functions fs = newXNOR(originalManager, originalFunction, newManager);

			Decomp2 *first = new Decomp2();
			Decomp2 *second = new Decomp2();
			decomp -> save(first, second, XNOR);

			decompositionManager(originalManager, fs.originalFunction, first);
			decompositionManager(newManager, fs.newFunction, second);
			break;
		}
		default:
			//it's not possible to do another decomposition
			decomp -> makeList(getOutput(originalManager, originalFunction));

			Cudd_RecursiveDeref(originalManager, originalFunction);
			//cout << "nedereferovano: " << Cudd_CheckZeroRef(originalManager) << endl;
			Cudd_Quit(originalManager);
			break;
	}
}

/**
 * Creates output string for function.
 */
string getOutput(DdManager* manager, DdNode *function) {

	if (Cudd_IsConstant(Cudd_T(function)) && Cudd_IsConstant(Cudd_E(function))) {

		string output = ".names ";

		if (Cudd_IsComplement(function)) {
			output.append(inputNamess[Cudd_Regular(function) -> index]);
		} else {
			output.append(inputNamess[function -> index]);
		}

		output.append(" $replaceWithRealName");

		if (Cudd_IsComplement(function)) {
			output.append("\n0 1\n");
		} else {
			output.append("\n1 1\n");
		}

		return output;
	} else {
		//TODO this is terrible, need function from CUDD to write into string or char*
		FILE *file = fopen("bds2.tmp", "w");
		DdNode **outputs = new DdNode*[1];
		outputs[0] = function;

		Cudd_DumpBlifBody(manager, 1, outputs, inputNamess, tempOutputs, file, 0);
		delete[] outputs;
		fclose(file);

		string buf;
		string line;
		ifstream in("bds2.tmp");
		while (getline(in, line)) {
			buf += line;
			buf += "\n";
		}
		return buf;
	}
}

/**
 * Create set of variables above the cut. It's not affected by reordering. It fills set with variable's index.
 * cutLevel is index of variable for horizontal cut.
 *
 * Side Effects: It sets cut2.
 *
 */
void createCutt(DdManager *manager, int cutLevel) {
	clearCut();
	for (int i = 0; i < Cudd_ReadSize(manager); i++) {
		//cout << "on index " << i << " there is variable  " << Cudd_ReadInvPerm(manager, i) << endl;
		addToCut(Cudd_ReadInvPerm(manager, i));
		if (Cudd_ReadInvPerm(manager, i) == cutLevel) {
			break;
		}
	}
}

/**
 * Finds first gxd a set it for XOR decomposition
 */
void createGxd() {
	map<string, int>::iterator gxdIterator;
	for (gxdIterator = gxdd.begin(); gxdIterator != gxdd.end(); gxdIterator++) {
		if ((*gxdIterator).second == 3) {
			initGNX(gxdNodess[(*gxdIterator).first]);
			break;
		}
	}
}

/**
 * Find all 0 and 1 leaf edges.
 *
 * Side Effects: It sets leafEdges0 and leafEdges1.
 *
 */
void findLeafEdgess(DdManager *manager, DdNode *function) {
	leafE0.clear();
	leafE1.clear();
	visitedNods.clear();
	DdNode *add = Cudd_BddToAdd(manager, function);
	Cudd_Ref(add);
	analyzeLeafss(add);
	Cudd_RecursiveDeref(manager, add);
}

void analyzeLeafss(DdNode *node) {

	if (Cudd_IsConstant(Cudd_T(node))) {
		//if else-edge is constant too, then this cut is not valid
		if (!Cudd_IsConstant(Cudd_E(node))) {
			if (Cudd_V(Cudd_T(node)) == 1) {
				//add 1-leaf edge for index of node
				add11(node -> index);
			} else {
				//add 0-leaf edge for index of node
				add00(node -> index);
			}
		}
	} else {
		if (visitedNods.find(getNodeIndex(Cudd_T(node))) == visitedNods.end()) {
			analyzeLeafss(Cudd_T(node));
		}
	}

	if (Cudd_IsConstant(Cudd_E(node))) {
		//if then-edge is constant too, then this cut is not valid
		if (!Cudd_IsConstant(Cudd_T(node))) {
			if (Cudd_V(Cudd_E(node)) == 1) {
				//add 1-leaf edge for index of node
				add11(node -> index);
			} else {
				//add 0-leaf edge for index of node
				add00(node -> index);
			}
		}
	} else {
		if (visitedNods.find(getNodeIndex(Cudd_E(node))) == visitedNods.end()) {
			analyzeLeafss(Cudd_E(node));
		}
	}

	visitedNods.insert(getNodeIndex(node));
}

void add00(int index) {
	if (leafE0.find(index) == leafE0.end()) {
		leafE0[index] = 1;
	} else {
		leafE0[index]++;
	}
}

void add11(int index) {
	if (leafE1.find(index) == leafE1.end()) {
		leafE1[index] = 1;
	} else {
		leafE1[index]++;
	}
}

/**
 * Find all generalized x-dominators..
 *
 * Side Effects: It sets gxd.
 *
 */
void findGXDD(DdNode *function) {
	visitedNods.clear();
	gxdd.clear();
	gxdNodess.clear();
	analyzeGXDSS(function);
}

void analyzeGXDSS(DdNode *node) {
	if (!Cudd_IsConstant(Cudd_T(node))) {

		addRR(getNodeIndex(Cudd_T(node)));

		if (visitedNods.find(getNodeIndex(Cudd_T(node))) == visitedNods.end()) {
			analyzeGXDSS(Cudd_T(node));
		}
	}

	if (!Cudd_IsConstant(Cudd_E(node))) {

		if (Cudd_IsComplement(Cudd_E(node))) {
			addCC(getNodeIndex(Cudd_Regular(Cudd_E(node))), Cudd_Regular(Cudd_E(node)));
			if (visitedNods.find(getNodeIndex(Cudd_Regular(Cudd_E(node)))) == visitedNods.end()) {
				analyzeGXDSS(Cudd_Regular(Cudd_E(node)));
			}
		} else {
			addRR(getNodeIndex(Cudd_E(node)));
			if (visitedNods.find(getNodeIndex(Cudd_E(node))) == visitedNods.end()) {
				analyzeGXDSS(Cudd_E(node));
			}
		}
	}

	visitedNods.insert(getNodeIndex(node));
}

void addRR(string id) {
	if (gxdd.find(id) == gxdd.end()) {
		gxdd[id] = 1;
	} else {
		if (gxdd[id] == 2) {
			gxdd[id] = 3;
		}
	}
}

void addCC(string id, DdNode *node) {
	gxdNodess[id] = node;
	if (gxdd.find(id) == gxdd.end()) {
		gxdd[id] = 2;
	} else {
		if (gxdd[id] == 1) {
			gxdd[id] = 3;
		}
	}
}

/**
 * Return best decomposition type. Must be call after findLeafEges(Decomp*) and findGXD(Decomp*)
 *
 * Side Effects: It sets maxAndCut, indexMaxAndCut, maxOrCut, indexMaxOrCut
 *
 */
int chooseDecompositionn() {
	maxAndCutt = 0;
	indexMaxAndCutt = 0;

	maxOrCutt = 0;
	indexMaxOrCutt = 0;

	int posibbleAndCutCount = leafE0.size();
	searchIndexMaxAndCutt();
	int posibbleOrCutCount = leafE1.size();
	searchIndexMaxOrCutt();
	int GXDcount = getGXDCountt();

	//cout << "\n" << endl;
	//cout << "AND cut count: " << posibbleAndCutCount << "  max: " << maxAndCutt << " (" << indexMaxAndCutt << ")" << endl;
	//cout << "OR cut count: " << posibbleOrCutCount << "  max: " << maxOrCutt << " (" << indexMaxOrCutt << ")" << endl;
	//cout << "GXDs count: " << GXDcount << endl;
	//cout << "\n" << endl;

	if (maxAndCutt == 0 && maxOrCutt == 0 && GXDcount == 0) {
		//anything else to do
		return 0;
	}

	//simple heuristic
	if ((posibbleAndCutCount + posibbleOrCutCount) > 0) {
		if (maxAndCutt > maxOrCutt) {
			return AND;
		} else {
			return OR;
		}
	} else {
		return XNOR;
	}
}

/**
 * Search max count of cuts for AND decompsition.
 *
 * Side Effects: It sets maxAndCut, indexMaxAndCut
 *
 */
void searchIndexMaxAndCutt() {
	map<int, int>::iterator it;
	for (it = leafE0.begin(); it != leafE0.end(); it++) {
		//cout << "na indexu: "  << (*it).first << "  and: " << (*it).second;
		if ((*it).second > maxAndCutt) {
			maxAndCutt = (*it).second;
			indexMaxAndCutt = (*it).first;
		}
	}
}

/**
 * Search max count of cuts for OR decompsition.
 *
 * Side Effects: It sets maxOrCut, indexMaxOrCut
 *
 */
void searchIndexMaxOrCutt() {
	map<int, int>::iterator it;
	for (it = leafE1.begin(); it != leafE1.end(); it++) {
		if ((*it).second > maxOrCutt) {
			maxOrCutt = (*it).second;
			indexMaxOrCutt = (*it).first;
		}
	}
}

/**
 * Return count of generalized x-dominators.
 */
int getGXDCountt() {
	int GXDcount = 0;
	map<string, int>::iterator ite;
	for (ite = gxdd.begin(); ite != gxdd.end(); ite++) {
		//cout << (*ite).first << " GXD=> " << (*ite).second << endl;
		if ((*ite).second == 3) {
			GXDcount++;
		}
	}
	return GXDcount;
}

void proceedDecompp(Decomp2 *decomp, FILE *file, string funcName) {
	if (decomp -> list) {
		string output = decomp -> textik;
		size_t found = output.find("$replaceWithRealName");
		if (found != string::npos) {
			output.replace(found, 20, funcName.c_str());
		} else {
			cerr << "$replaceWithRealName not found, serious error" << endl;
		}

		fputs(output.c_str(), file);
	} else {
		string left, right;
		switch (decomp -> oper) {
			case AND: {
				stringstream out;
				out << "Q" << countANDD;
				left = out.str();
				out.str("");
				out << "D" << countANDD;
				right = out.str();
				countANDD++;
				fputs(".names ", file);
				fputs(left.c_str(), file);
				fputs(" ", file);
				fputs(right.c_str(), file);
				fputs(" ", file);
				fputs(funcName.c_str(), file);
				fputs("\n11 1\n", file);
				break;
			}
			case OR: {
				stringstream out;
				out << "H" << countORR;
				left = out.str();
				out.str("");
				out << "G" << countORR;
				right = out.str();
				countORR++;
				fputs(".names ", file);
				fputs(left.c_str(), file);
				fputs(" ", file);
				fputs(right.c_str(), file);
				fputs(" ", file);
				fputs(funcName.c_str(), file);
				fputs("\n1- 1\n-1 1\n", file);
				break;
			}
			case XNOR: {
				stringstream out;
				out << "XH" << countXNORR;
				left = out.str();
				out.str("");
				out << "XG" << countXNORR;
				right = out.str();
				countXNORR++;
				fputs(".names ", file);
				fputs(left.c_str(), file);
				fputs(" ", file);
				fputs(right.c_str(), file);
				fputs(" ", file);
				fputs(funcName.c_str(), file);
				fputs("\n11 1\n00 1\n", file);
				break;
			}

			default:
				cerr << "unknown opearation found" << endl;
				exit(1);
		}

		proceedDecompp(decomp -> L, file, left);
		proceedDecompp(decomp -> R, file, right);
	}
}

//void old() {
//tohle dava sice jeden memory leak, ale pro 2000 zaznamu to je jen 16kb
//tak nedava, kdyz se to zavola v metode (simuluje if) tak se smaze i vector

/*if (true) {
 vector<DdManager*> manageri;

 for (int i = 0; i < 200; i++) {
 DdManager *manager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
 manageri.push_back(manager);
 }

 for (int i = 0; i < 200; i++) {
 Cudd_Quit(manageri.back());
 manageri.pop_back();
 }
 }

 if (true) {
 vector<string> vec;

 for (int i = 0; i < 10000; i++) {
 string s("das");
 vec.push_back(s);
 }

 vec.clear();
 }*/

/*
 if (true) {
 Test *testik = new Test();

 Test *testik1 = new Test();
 testik1 -> makeList("jedna");
 Test *testik2 = new Test();
 Test *testik3 = new Test();
 testik3 -> makeList("tri");
 Test *testik4 = new Test();
 testik4 -> makeList("ctyri");

 testik -> save(testik1, testik2, 0);
 testik2 -> save(testik3, testik4, 0);

 delete testik;
 }
 */

//Cudd_ReduceHeap(manager, CUDD_REORDER_SAME, 1);

/*FILE *file = fopen("pokus.dot", "w");
 DdNode **outputs = new DdNode*[1];
 outputs[0] = e;

 Cudd_DumpDot(manager, 1, outputs, NULL, NULL, file);
 delete[] outputs;
 fclose(file);*/

//findLeafEdgess(manager, e);
//findGXDD(e);
//chooseDecompositionn();

//clearCut();
//addToCut(0);
//addToCut(1);
//DdManager *newManager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
//functions fs = newOR(manager, e, newManager);


//Cudd_RecursiveDeref(manager, fs.originalFunction);
//cout << "nedereferovano: " << Cudd_CheckZeroRef(manager) << endl;

//Cudd_RecursiveDeref(newManager, fs.newFunction);
//cout << "nedereferovano: " << Cudd_CheckZeroRef(newManager) << endl;

//Cudd_Quit(manager);
//Cudd_Quit(newManager);

/*
 managerFunction manFun = vratNeco();
 Cudd_Quit(manFun.manager);
 */
//}

/*managerFunction vratNeco() {
 DdManager *manager = Cudd_Init(0, 0, CUDD_UNIQUE_SLOTS, 600, 0);
 DdNode *node = Cudd_ReadOne(manager);

 managerFunction manFun;
 manFun.function = node;
 manFun.manager = manager;

 return manFun;
 }*/
